#include "table_output.h"

using namespace tbo;

void article_01();
void article_02();
void article_03();
void article_04();
void article_05();
void article_06();
void article_07();
void article_08();
void article_09();
void article_10();
void article_11();
void article_12();
void article_13();
void article_14();
void article_15();

void main( int argc, const char* argv[] )
{
	void ( * article_funcs[] )() = {
		article_01,
		article_02,
		article_03,
		article_04,
		article_05,
		article_06,
		article_07,
		article_08,
		article_09,
		article_10,
		article_11,
		article_12,
		article_13,
		article_14,
		article_15,
	};

	int article = std::extent< decltype( article_funcs ) >::value;

	for ( int i = 1; i < argc; ++i )
	{
		if ( strlen( argv[ i ] ) == 2 && argv[ i ][ 0 ] == '-' )
		{
			if ( argv[ i ][ 1 ] == 'h' )
			{
				CTable::sSetOutputSetting( CTable::HumanReadable );
			}
			else if ( argv[ i ][ 1 ] == 'c' )
			{
				CTable::sSetOutputSetting( CTable::CSV );
			}
		}
		else
		{
			article = atoi( argv[ 1 ] );
			if ( article < 1 || article > std::extent< decltype( article_funcs ) >::value )
			{
				article = 1;
			}
		}
	}

	CTable( "Article %d", article ).Print();
	CTable( "Unless otherwise stated, we assume 17 lands in a 40 card deck, with a 7-card starting hand that includes 3 lands." ).Print();

	article_funcs[ article - 1 ]();

	if ( CTable::sGetOutputSetting() == CTable::HumanReadable )
	{
		getchar();
	}
}